#include "svg.h"
#include <iostream>
#include<string>
void svg_begin(double width, double height) {
    std::cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    std::cout << "<svg ";
    std::cout << "width='" << width << "' ";
    std::cout << "height='" << height << "' ";
    std::cout << "viewBox='0 0 " << width << " " << height << "' ";
    std::cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void svg_end() {
    std::cout << "</svg>\n";
}

void
svg_text(double left, double baseline, std::string text) {
    std::cout << "<text x='" << left << "' y='" << baseline << "'>"<<text<<"</text>";
}

void svg_rect(double x, double y, double width, double height,std::string stroke = "black", std::string fill = "black") {
    std::cout << "<rect x='"<<x<<"' y='"<<y<<"' width='"<<width<<"' height='"<<height<<"' stroke='"<<stroke<<"' fill='"<<fill<<"'/>";
}
//std::string bin_color(size_t bin, size_t mxbins) {
//    return("#" + std::to_string((10 - floor((bin) * 9 / mxbins))) + std::to_string((10 - floor((bin) * 9 / mxbins))) + std::to_string((10 - floor((bin) * 9 / mxbins))));
//}

void show_histogram_svg(const std::vector<size_t>& bins, size_t bin_count) {
    const auto IMAGE_WIDTH = 400;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;
    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;
    const auto BLOCK_WIDTH = 10;
    double mxbins = bins[0];
    for (double x : bins)
    {
        if (x > mxbins)
            mxbins = x;
    }
    double k;
    if (mxbins > IMAGE_WIDTH-TEXT_WIDTH)
        k = floor((IMAGE_WIDTH - TEXT_WIDTH) / mxbins);
    else
        k = 1;
    svg_begin(IMAGE_WIDTH, IMAGE_HEIGHT);
    double top = 0;
    for (size_t bin : bins) {
       /* std::string color = bin_color(bin,mxbins);*/
        const double bin_width = BLOCK_WIDTH * bin*k;
        svg_text(TEXT_LEFT, top + TEXT_BASELINE, std::to_string(bin));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT, "red", "#ffeeee");///color,color   
        top += BIN_HEIGHT;
    }
    svg_end();
}


